<template>
  <div>
    <el-tree
      :data="treeData"
      show-checkbox
      node-key="id"
      default-expand-all
      :expand-on-click-node="false"
      :render-content="renderContent"
    >
    </el-tree>
    <pre>{{ JSON.stringify(treeData, null, 2) }}</pre>
  </div>
</template>

<script>
import { mapState } from "vuex";

let id = 1000;
export default {
  data() {
    return {
      /* data: [
        {
          id: 1,
          label: "Level one 1",
          children: [
            {
              id: 4,
              label: "Level two 1-1",
              children: [
                {
                  id: 9,
                  label: "Level three 1-1-1",
                },
                {
                  id: 10,
                  label: "Level three 1-1-2",
                },
              ],
            },
          ],
        },
        {
          id: 2,
          label: "Level one 2",
          children: [
            {
              id: 5,
              label: "Level two 2-1",
            },
            {
              id: 6,
              label: "Level two 2-2",
            },
          ],
        },
        {
          id: 3,
          label: "Level one 3",
          children: [
            {
              id: 7,
              label: "Level two 3-1",
            },
            {
              id: 8,
              label: "Level two 3-2",
            },
          ],
        },
      ], */
    };
  },

  computed: {
    ...mapState({
      treeData: (state) => state.data,
    }),
  },

  created() {
    console.log(this.treeData);
  },

  methods: {
    search(tree, target) {
      if (tree.id === target) {
        return tree;
      }

      if (tree.children) {
        for (const child of tree.children) {
          const res = this.search(child, target);

          if (res) {
            return res;
          }
        }
      } else {
        console.log("hi!");
      }
    },
    append(node, data) {
      //console.log(data);
      const newChild = { id: id++, label: "testtest", children: [] };
      if (!data.children) {
        this.$set(data, "children", []);
      }
      //console.log(data);
      data.children.push(newChild);
      this.$store.commit("SET_TREE_DATA", node.store.data);
    },

    remove(node, data) {
      this.treeData.forEach((i) => {
        let id = this.search(i, data.id);
        console.log(id);
      });

      //id.splice(index, 1);
      const parent = node.parent;
      const children = parent.data.children || parent.data;
      const index = children.findIndex((d) => d.id === data.id);

      children.splice(index, 1);
      console.log(node.store.data);
      this.$store.commit("SET_TREE_DATA", node.store.data);
    },

    renderContent(h, { node, data }) {
      return (
        <span class="custom-tree-node">
          <span>{node.label}</span>
          <span>
            <el-button
              size="mini"
              type="text"
              on-click={() => this.append(node, data)}
            >
              Append
            </el-button>
            <el-button
              size="mini"
              type="text"
              on-click={() => this.remove(node, data)}
            >
              Delete
            </el-button>
          </span>
        </span>
      );
    },
  },
};
</script>

<style>
</style>